import { HttpClient } from '@angular/common/http';
import { ViewModelInterface } from './asViewModel.interface';
import { FilterInterface } from './asFilter.interface';
import { AsComponent } from './as.component';
import { OnInit, Renderer2, ElementRef, OnDestroy } from '@angular/core';
import { Subject } from 'rxjs';
import { ControlValueAccessor } from '@angular/forms';
import { AsConfigService } from './asConfig.service';
import { NgbTypeaheadSelectItemEvent, NgbDropdown } from '@ng-bootstrap/ng-bootstrap';
import { AfterViewInit } from '@angular/core';
import { Subscription } from 'rxjs';
export declare abstract class AsBoxFilterAbstract implements OnInit, OnDestroy, FilterInterface, AfterViewInit, ControlValueAccessor {
    advancedSearchBox: AsComponent;
    _renderer: Renderer2;
    _el: ElementRef;
    _http: HttpClient;
    _config: AsConfigService;
    viewModel: ViewModelInterface;
    operatorsDropDownDir: NgbDropdown;
    buttonToggleEr: ElementRef;
    inputComponent: any;
    private _isFirstDocClick;
    inputClickUnsubscribe$_: Subscription;
    focusInput$: Subject<any>;
    constructor(advancedSearchBox: AsComponent, _renderer: Renderer2, _el: ElementRef, _http: HttpClient, _config: AsConfigService);
    protected _onChange: (val: any) => void;
    writeValue(val: any): void;
    registerOnChange(fn: (val: any) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    ngAfterViewInit(): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    onFocus(prevNext: any): void;
    onBlur(): void;
    remove(): void;
    removeEmpty(models: any[]): boolean;
    getKeys(object: any): any[];
    viewToModel(): void;
    clickout(event: any): void;
    resize(event: any): void;
    onSelectDomains($event: any): void;
    onSelectSuggestions($event: NgbTypeaheadSelectItemEvent): void;
    focusInput(): void;
    blurInput(): void;
    maxWidthInput(): void;
}
