import { ViewModelInterface } from './../asViewModel.interface';
import { Subject, OperatorFunction } from 'rxjs';
import { ElementRef, OnInit } from '@angular/core';
import { AsConfigService } from './../asConfig.service';
import { HttpClient } from '@angular/common/http';
import { AsComponent } from "../as.component";
import { Observable } from "rxjs";
import { AsInputInterface } from './asInput.interface';
import { ReplaySubject } from 'rxjs';
import { NgModel, ControlValueAccessor, FormGroup } from '@angular/forms';
import { EventEmitter } from '@angular/core';
export declare abstract class AsInputAbstract implements OnInit, AsInputInterface, ControlValueAccessor {
    advancedSearchBox: AsComponent;
    protected _http: HttpClient;
    protected _config: AsConfigService;
    _element: ElementRef;
    focusInput$: Subject<any>;
    domainsResults$: ReplaySubject<any>;
    suggestionsResults$: ReplaySubject<any>;
    searchboxInputClick$: Observable<any>;
    suggestionsFormatter: (viewModel: ViewModelInterface) => any;
    domainsFormatter: any;
    suggestionsFunc: any;
    domainsFunc: any;
    domainTypeahead: Observable<any>;
    itemsDomain: any[];
    form: FormGroup;
    abstract filter: any;
    domainsAsyncSubject: Subject<{}>;
    inputRef: any;
    inputElementRef: ElementRef;
    typeaheadController: any;
    ngModel: NgModel;
    change: EventEmitter<any>;
    constructor(advancedSearchBox: AsComponent, _http: HttpClient, _config: AsConfigService, _element: ElementRef);
    _onChange: (val: any) => void;
    writeValue(val: any): void;
    registerOnChange(fn: (val: any) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    ngOnInit(): void;
    private _filterNotDuplicate(type);
    filterNotDuplicateDomains(): OperatorFunction<any, any>;
    filterNotDuplicateSuggestions(): OperatorFunction<any, any>;
}
