import { ViewModelInterface } from './asViewModel.interface';
import { Subject } from 'rxjs';
import { HttpClient } from '@angular/common/http';
import { Observable } from "rxjs";
import { ReplaySubject } from "rxjs";
export declare class AsConfigService {
    private _http;
    private _navigation;
    customDomainsFormatter: {
        [key: string]: (viewModel: ViewModelInterface, val: any) => any;
    };
    customDomainsModelFormatter: {
        [key: string]: (viewModel: ViewModelInterface, val: any) => any;
    };
    customSuggestionsFormatter: {
        [key: string]: (viewModel: ViewModelInterface) => any;
    };
    formatModelValue: {
        [key: string]: (val: any) => Object | String;
    };
    formatModelViewValue: {
        [key: string]: (val: any, template: any) => Object | String;
    };
    customSuggestionsStaticFn: {
        [key: string]: (observable: Observable<any>, viewModel: ViewModelInterface, model: any) => any;
    };
    customSuggestionsAsyncFn: {
        [key: string]: (observable: Observable<any>, viewModel: ViewModelInterface, model: any) => any;
    };
    customDomainsStaticFn: {
        [key: string]: (observable: Observable<any>, viewModel: ViewModelInterface, model: any) => any;
    };
    customDomainsAsyncFn: {
        [key: string]: (observable: Observable<any>, viewModel: ViewModelInterface, model: any) => any;
    };
    domainsFormatter: (viewModel: ViewModelInterface, model: any) => any;
    domainsModelFormatter: (viewModel: ViewModelInterface, model: any) => any;
    suggestionsFormatter: (viewModel: ViewModelInterface) => any;
    domainsAsyncSubject: Subject<any>;
    constructor(_http: HttpClient);
    suggestionsStaticFn(observable: Observable<any>, viewModel: any, suggestions: any): Observable<any>;
    suggestionsAsyncFn(observable: Observable<any>, viewModel: any, suggestions: any): Observable<any>;
    domainsStaticFn(observable: Observable<any>, viewModel: any, model: any): Observable<any>;
    domainsAsyncFn(observable: Observable<any>, viewModel: any, model: any): Observable<any>;
    navigation: ReplaySubject<any>;
    historyNavigation: any;
}
