import { AsComponent } from './as.component';
import { OnInit, Renderer2, ElementRef, ComponentFactoryResolver } from '@angular/core';
import { AsBoxFilterAbstract } from './asFilter.abstract';
import { HttpClient } from '@angular/common/http';
import { AsConfigService } from './asConfig.service';
export declare enum TypesInputEnum {
    SIMPLE = "SIMPLE",
    SIMPLE_MASK = "SIMPLE_MASK",
    SUGGESTIONS = "SUGGESTIONS",
    DOMAINS = "DOMAINS",
}
export declare class AsInputComponent extends AsBoxFilterAbstract implements OnInit {
    advancedSearchBox: AsComponent;
    _renderer: Renderer2;
    _el: ElementRef;
    _http: HttpClient;
    _config: AsConfigService;
    protected resolver: ComponentFactoryResolver;
    inputType: TypesInputEnum;
    constructor(advancedSearchBox: AsComponent, _renderer: Renderer2, _el: ElementRef, _http: HttpClient, _config: AsConfigService, resolver: ComponentFactoryResolver);
    ngOnInit(): void;
    onBlur(): void;
    onChange(): void;
}
