import { HttpClient } from '@angular/common/http';
import { AsComponent } from './as.component';
import { OnInit, Renderer2, ElementRef, OnChanges, SimpleChanges, ComponentFactoryResolver } from '@angular/core';
import { AsBoxFilterAbstract } from './asFilter.abstract';
import { AsConfigService } from './asConfig.service';
export declare enum TypesInputWithOperatorsEnum {
    SIMPLE = "SIMPLE",
    SIMPLE_MASK = "SIMPLE_MASK",
    SUGGESTIONS = "SUGGESTIONS",
    DOMAINS = "DOMAINS",
}
export declare class AsInputWithOperatorsComponent extends AsBoxFilterAbstract implements OnInit, OnChanges {
    advancedSearchBox: AsComponent;
    renderer: Renderer2;
    el: ElementRef;
    _http: HttpClient;
    _config: AsConfigService;
    protected resolver: ComponentFactoryResolver;
    operatorsList: any;
    operatorsEnum: any;
    inputType: TypesInputWithOperatorsEnum;
    constructor(advancedSearchBox: AsComponent, renderer: Renderer2, el: ElementRef, _http: HttpClient, _config: AsConfigService, resolver: ComponentFactoryResolver);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnInit(): void;
    onBlur(): void;
    onFocus(prevNext: any): void;
    onChange(): void;
    onChangeOperators($event: MouseEvent | KeyboardEvent, operator: string): void;
    onSelectDomains(data: any): void;
}
